format MZ
entry Main:EntryPoint
stack 0x100
use16

segment SST							       ;String Table
  SSTxA db  'ͻ', 0xD, 0xA      ;String Table/About
	db  '             VjuMSW 0.0.1              ', 0xD, 0xA
	db  '͹', 0xD, 0xA
	db  ' Mashine Status Word Viewer ver. 0.0.1 ', 0xD, 0xA
	db  ' (C) Dutkevich Konstantin aka Nasarus  ', 0xD, 0xA
	db  '  Build #024. Compiled at 02.03.2010   ', 0xD, 0xA
	db  'ͼ', 0xD, 0xA, 0xD, 0xA, '$'

  SSTxCR00     db  'Processor Mode:         ', '$'		       ;String Table/CR0,  0
  SSTxCR00x0   db  'Real', 0xD, 0xA, '$'			       ;String Table/CR0,  0 = 0
  SSTxCR00x1   db  'Protected', 0xD, 0xA, '$'			       ;String Table/CR0,  0 = 1

  SSTxCR01     db  'Co-Processor:           ', '$'
  SSTxCR01x0   db  'Not present', 0xD, 0xA, '$'
  SSTxCR01x1   db  'Present', 0xD, 0xA, '$'

  SSTxCR02     db  'Co-Processor Emulation: ', '$'

  SSTxCR03     db  'Task switching:         ', '$'

  SSTxCR04     db  'Co-Processor Type:      ', '$'
  SSTxCR04x0   db  'External', 0xD, 0xA, '$'
  SSTxCR04x1   db  'Internal', 0xD, 0xA, '$'

  SSTxCR05     db  'FPU Error Handling:     ', '$'

  SSTxCR016    db  'Writing Protection:     ', '$'

  SSTxCR018    db  'Alignment Control:      ', '$'

  SSTxCR029    db  'Write-through mode:     ', '$'

  SSTxCR030    db  'Caching disabled:       ', '$'
  SSTxCR030x0  db  'Yes', 0xD, 0xA, '$'
  SSTxCR030x1  db  'No', 0xD, 0xA, '$'

  SSTxCR031    db  'Memory Paging:          ', '$'

  SSTxD        db  'Disabled', 0xD, 0xA, '$'
  SSTxE        db  'Enabled', 0xD, 0xA, '$'

  SSTxExit     db  0xD, 0xA, 'Press any key to exit', '$'

segment Main
  EntryPoint:
    call SMxCS

    push SST
    pop DS
    mov AH, 9	      ;   VjuMSW
    mov DX, SSTxA
    int 0x21

    call SMxDP

    mov AH, 9	      ;    
    mov DX, SSTxExit
    int 0x21
    mov AX, 0xC08     ;  
    int 0x21

    mov AX, 0x4C00
    int 0x21
  SMxCS:	      ;Main/Clear Screen
    mov AH, 0xF       ; 
    int 0x10	      ;    2,3  7,   2
    cmp AL, 2
    je C2
    cmp AL, 3
    je C2
    cmp AL, 7
    je C2

    C1: 	      ;SMxCS/Case 1
      mov AX, 2       ;  2
      int 0x10
      retn
       
    C2: 	      ;SMxCS/Case 2
      mov AX, 0x600   ;  
      mov BH, 7       ;    
      xor CX, CX
      mov DX, 0x184F  ;    (79;24)
      int 0x10
      mov AH, 2       ;   (0;0)
      xor BH, BH
      xor DX, DX
      int 0x10
      retn
  SMxDP:
    mov AH, 9		 ;  

    mov DX, SSTxCR00
    int 0x21
    smsw EBX		 ; MSW(CR0)  EAX
    and EBX, 0x00000001  ; 0
    jz CR00x0
    mov DX, SSTxCR00x1
    int 0x21
    jmp Bit1
    CR00x0:
    mov DX, SSTxCR00x0
    int 0x21

    Bit1:
    mov DX, SSTxCR01
    int 0x21
    smsw EBX
    and EBX, 0x00000002  ; 1
    jz CR01x0
    mov DX, SSTxCR01x1
    int 0x21
    jmp Bit2
    CR01x0:
    mov DX, SSTxCR01x0
    int 0x21

    Bit2:
    mov DX, SSTxCR02
    int 0x21
    smsw EBX
    and EBX, 0x00000004  ; 2
    jz CR02x0
    mov DX, SSTxE
    int 0x21
    jmp Bit3
    CR02x0:
    mov DX, SSTxD
    int 0x21

    Bit3:
    mov DX, SSTxCR03
    int 0x21
    smsw EBX
    and EBX, 0x00000008  ; 3
    jz CR03x0
    mov DX, SSTxE
    int 0x21
    jmp Bit4
    CR03x0:
    mov DX, SSTxD
    int 0x21

    Bit4:
    mov DX, SSTxCR04
    int 0x21
    smsw EBX
    and EBX, 0x00000010  ; 4
    jz CR04x0
    mov DX, SSTxCR04x1
    int 0x21
    jmp Bit5
    CR04x0:
    mov DX, SSTxCR04x0
    int 0x21

    Bit5:
    mov DX, SSTxCR05
    int 0x21
    smsw EBX
    and EBX, 0x00000020  ; 5
    jz CR05x0
    mov DX, SSTxE
    int 0x21
    jmp Bit16
    CR05x0:
    mov DX, SSTxD
    int 0x21

    Bit16:
    mov DX, SSTxCR016
    int 0x21
    smsw EBX
    and EBX, 0x00010000  ; 16
    jz CR016x0
    mov DX, SSTxE
    int 0x21
    jmp Bit18
    CR016x0:
    mov DX, SSTxD
    int 0x21

    Bit18:
    mov DX, SSTxCR018
    int 0x21
    smsw EBX
    and EBX, 0x00040000  ; 18
    jz CR018x0
    mov DX, SSTxE
    int 0x21
    jmp Bit29
    CR018x0:
    mov DX, SSTxD
    int 0x21

    Bit29:
    mov DX, SSTxCR029
    int 0x21
    smsw EBX
    and EBX, 0x20000000  ; 29
    jz CR029x0
    mov DX, SSTxE
    int 0x21
    jmp Bit30
    CR029x0:
    mov DX, SSTxD
    int 0x21

    Bit30:
    mov DX, SSTxCR030
    int 0x21
    smsw EBX
    and EBX, 0x40000000  ; 30
    jz CR030x0
    mov DX, SSTxCR030x1
    int 0x21
    jmp Bit31
    CR030x0:
    mov DX, SSTxCR030x0
    int 0x21

    Bit31:
    mov DX, SSTxCR031
    int 0x21
    smsw EBX
    and EBX, 0x80000000  ; 31
    jz CR031x0
    mov DX, SSTxE
    int 0x21
    retn
    CR031x0:
    mov DX, SSTxD
    int 0x21

    retn